Subject: bug#30290: guix-daemon slows to a crawl when a substitute server is offline

From: Efraim Flashner <[email-masked]>
Date: Mon, 28 Dec 2020 14:19:02 +0200

On Tue, Dec 22, 2020 at 04:16:08PM +0100, Ludovic Courtès wrote:
> Hi,
> 
> Maxim Cournoyer <[email-masked]> skribis:
> 
> > When a substitute server used by guix-daemon is offline, the daemon will
> > keep attempting to connect to it, even when it shouldn't need any data
> > (ran 'sudo guix system reconfigure my-config.scm' multiple times in a
> > row.
> >
> > With the disconnected server (bayfront in my case), that command would
> > take close to 8 minutes, with many system calls like:
> >
> > connect(14, {sa_family=AF_INET, sin_port=htons(443), sin_addr=inet_addr("141.255.128.56")}, 16) = -1 EINPROGRESS
> >
> > which wasted 5 seconds each time.
> 
> Is it still a problem?  Commit 4f5234be0378368e6af25925db46612838d25e58
> (Nov. 2019) added a table of unreachable hosts.  That way, a ‘guix
> substitute --query’ process won’t retry connections to an unreachable
> host.
> 
> Ludo’.
> 

Occasionally my internet drops itself, and I find I'm left forever
waiting for a timeout to see what sources I have cached locally.

-- 
Efraim Flashner   <[email-masked]>   אפרים פלשנר
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted